#! /usr/bin/env sh

echo "Running inside /app/prestart.sh..."

echo "Running migrations..."
python /app/taranis-ng-core/db_migration.py db upgrade head
echo "Done."

if [[ -n "$TARANIS_NG_SAMPLE_DATA" ]]; then

    python manage.py sample-data

elif [[ -n "$TARANIS_NG_ADMIN_USERNAME" && -n "$TARANIS_NG_ADMIN_PASSWORD" ]]; then

    python manage.py role \
        --create \
        --name "Admin role" \
        --description "Administrator role with full privileges" \
        --permissions "ANALYZE_ACCESS, ANALYZE_CREATE, ANALYZE_UPDATE, \
        ANALYZE_DELETE, ASSESS_ACCESS, ASSESS_CREATE, ASSESS_UPDATE, \
        ASSESS_DELETE, MY_ASSETS_ACCESS, MY_ASSETS_CREATE, MY_ASSETS_CONFIG, \
        CONFIG_ACCESS, CONFIG_ORGANIZATION_ACCESS, CONFIG_ORGANIZATION_CREATE, \
        CONFIG_ORGANIZATION_UPDATE, CONFIG_ORGANIZATION_DELETE, CONFIG_USER_ACCESS, \
        CONFIG_USER_CREATE, CONFIG_USER_UPDATE, CONFIG_USER_DELETE, CONFIG_ROLE_ACCESS, \
        CONFIG_ROLE_CREATE, CONFIG_ROLE_UPDATE, CONFIG_ROLE_DELETE, CONFIG_ACL_ACCESS, \
        CONFIG_ACL_CREATE, CONFIG_ACL_UPDATE, CONFIG_ACL_DELETE, CONFIG_PRODUCT_TYPE_ACCESS, \
        CONFIG_PRODUCT_TYPE_CREATE, CONFIG_PRODUCT_TYPE_UPDATE, CONFIG_PRODUCT_TYPE_DELETE, \
        CONFIG_ATTRIBUTE_ACCESS, CONFIG_ATTRIBUTE_CREATE, CONFIG_ATTRIBUTE_UPDATE, \
        CONFIG_ATTRIBUTE_DELETE, CONFIG_REPORT_TYPE_ACCESS, CONFIG_REPORT_TYPE_CREATE, \
        CONFIG_REPORT_TYPE_UPDATE, CONFIG_REPORT_TYPE_DELETE, CONFIG_WORD_LIST_ACCESS, \
        CONFIG_WORD_LIST_CREATE, CONFIG_WORD_LIST_UPDATE, CONFIG_WORD_LIST_DELETE, \
        CONFIG_COLLECTORS_NODE_ACCESS, CONFIG_COLLECTORS_NODE_CREATE, \
        CONFIG_COLLECTORS_NODE_UPDATE, CONFIG_COLLECTORS_NODE_DELETE, \
        CONFIG_OSINT_SOURCE_ACCESS, CONFIG_OSINT_SOURCE_CREATE, CONFIG_OSINT_SOURCE_UPDATE, \
        CONFIG_OSINT_SOURCE_DELETE, CONFIG_OSINT_SOURCE_GROUP_ACCESS, \
        CONFIG_OSINT_SOURCE_GROUP_CREATE, CONFIG_OSINT_SOURCE_GROUP_UPDATE, \
        CONFIG_OSINT_SOURCE_GROUP_DELETE, CONFIG_REMOTE_ACCESS_ACCESS, \
        CONFIG_REMOTE_ACCESS_CREATE, CONFIG_REMOTE_ACCESS_UPDATE, \
        CONFIG_REMOTE_ACCESS_DELETE, CONFIG_REMOTE_NODE_ACCESS, CONFIG_REMOTE_NODE_CREATE, \
        CONFIG_REMOTE_NODE_UPDATE, CONFIG_REMOTE_NODE_DELETE, CONFIG_PRESENTERS_NODE_ACCESS, \
        CONFIG_PRESENTERS_NODE_CREATE, CONFIG_PRESENTERS_NODE_UPDATE, \
        CONFIG_PRESENTERS_NODE_DELETE, CONFIG_PUBLISHERS_NODE_ACCESS, \
        CONFIG_PUBLISHERS_NODE_CREATE, CONFIG_PUBLISHERS_NODE_UPDATE, \
        CONFIG_PUBLISHERS_NODE_DELETE, CONFIG_PUBLISHER_PRESET_ACCESS, \
        CONFIG_PUBLISHER_PRESET_CREATE, CONFIG_PUBLISHER_PRESET_UPDATE, \
        CONFIG_PUBLISHER_PRESET_DELETE, CONFIG_BOTS_NODE_ACCESS, CONFIG_BOTS_NODE_CREATE, \
        CONFIG_BOTS_NODE_UPDATE, CONFIG_BOTS_NODE_DELETE, CONFIG_BOT_PRESET_ACCESS, \
        CONFIG_BOT_PRESET_CREATE, CONFIG_BOT_PRESET_UPDATE, CONFIG_BOT_PRESET_DELETE, \
        CONFIG_PRESENTERS_NODE_ACCESS, CONFIG_PRESENTERS_NODE_CREATE, \
        CONFIG_PRESENTERS_NODE_UPDATE, CONFIG_PRESENTERS_NODE_DELETE, PUBLISH_ACCESS, \
        PUBLISH_CREATE, PUBLISH_UPDATE, PUBLISH_DELETE, PUBLISH_PRODUCT, \
        CONFIG_PUBLISHERS_NODE_ACCESS, CONFIG_PUBLISHERS_NODE_CREATE, \
        CONFIG_PUBLISHERS_NODE_UPDATE, CONFIG_PUBLISHERS_NODE_DELETE, \
        CONFIG_PUBLISHER_PRESET_ACCESS, CONFIG_PUBLISHER_PRESET_CREATE, \
        CONFIG_PUBLISHER_PRESET_UPDATE, CONFIG_PUBLISHER_PRESET_DELETE" || true

    ROLE_ID=$(python manage.py role --list --filter "Admin role" | grep -i id | awk '{print $2}')

    python manage.py account --create --username "$TARANIS_NG_ADMIN_USERNAME" --password "$TARANIS_PASSWORD" --roles $ROLE_ID

fi
